using Exferia_Aplicacion.Calculos.VentasCompras;
using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_Aplicacion.Visualizacion;
using Exferia_Compras._0_Modelos;
using Exferia_Compras.General;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Compras._3_Vistas.Listados
{
    public class ABS_Listado_COM_SolicitudesOfertasLineas_TarifasPromociones : ABS_Listado
    {
        //Variables privadas
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_COM_SolicitudesOfertasLineas_TarifasPromociones()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_TarifaPromocion_VentasCompras_Modelo.Id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_TarifaPromocion_VentasCompras_Modelo.Id), "id", G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));

            //Orden
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_TarifaPromocion_VentasCompras_Modelo.Orden), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_TarifaPromocion_VentasCompras_Modelo.Orden), "Orden", G_ENUM_TIPOSDATOS.INT, false, 100, true, true, true, false, "", null, false));

            //Tipo
            INTERNO_Filtro_Opciones_Modelo mdl_INTERNO_Filtro_Opciones_Modelo_TIPO = new INTERNO_Filtro_Opciones_Modelo();
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPO.MULTISELECCION = false;
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPO.LISTADO = new List<INTERNO_Filtro_Opciones_Listado_Modelo>();
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPO.LISTADO.Add(new INTERNO_Filtro_Opciones_Listado_Modelo(Variables.G_STR_TIPO_TARIFAPROMOCION_TARIFA_DESCRIPCION, Variables.G_STR_TIPO_TARIFAPROMOCION_TARIFA_DESCRIPCION));
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPO.LISTADO.Add(new INTERNO_Filtro_Opciones_Listado_Modelo(Variables.G_STR_TIPO_TARIFAPROMOCION_PROMOCIONES_DESCRIPCION, Variables.G_STR_TIPO_TARIFAPROMOCION_PROMOCIONES_DESCRIPCION));
            mdl_INTERNO_Filtro_Opciones_Modelo_TIPO.TIPO = 1;
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_TarifaPromocion_VentasCompras_Modelo.TarifaPromocion_Tipo_Texto), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_TarifaPromocion_VentasCompras_Modelo.TarifaPromocion_Tipo_Texto), "Tipo", G_ENUM_TIPOSDATOS.OPCIONES, false, 150, true, true, true, false, "", null, false, mdl_INTERNO_Filtro_Opciones_Modelo_TIPO));

            //Codigo
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_TarifaPromocion_VentasCompras_Modelo.TarifaPromocion_Codigo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_TarifaPromocion_VentasCompras_Modelo.TarifaPromocion_Codigo), "Código", G_ENUM_TIPOSDATOS.TEXT, false, 80, true, false, true, false, "", null, false));

            //Descripcion
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_TarifaPromocion_VentasCompras_Modelo.TarifaPromocion_Descripcion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_TarifaPromocion_VentasCompras_Modelo.TarifaPromocion_Descripcion), "Descripción", G_ENUM_TIPOSDATOS.TEXT, false, 200, true, false, true, false, "", null, false));

            //desactivado
            List<INTERNO_ABS_Listado_CondicionesColores_Modelo> lst_INTERNO_ABS_Listado_CondicionesColores_Modelo_DESACTIVADO = new List<INTERNO_ABS_Listado_CondicionesColores_Modelo>();
            lst_INTERNO_ABS_Listado_CondicionesColores_Modelo_DESACTIVADO.Add(new INTERNO_ABS_Listado_CondicionesColores_Modelo(new INTERNO_CodigoDescripcion_Modelo(Variables.G_MDL_INTERNO_CODIGODESCRIPCION_TIPOBUSQUEDA_GENERAL_IGUALA.Codigo, Variables.G_MDL_INTERNO_CODIGODESCRIPCION_TIPOBUSQUEDA_GENERAL_IGUALA.Descripcion), "V", Colores.G_COLOR_LETRA_CORRECTO, Colores.G_COLOR_LETRA_CORRECTO,false,Fuentes.G_FONT_SIGMAERP));
            lst_INTERNO_ABS_Listado_CondicionesColores_Modelo_DESACTIVADO.Add(new INTERNO_ABS_Listado_CondicionesColores_Modelo(new INTERNO_CodigoDescripcion_Modelo(Variables.G_MDL_INTERNO_CODIGODESCRIPCION_TIPOBUSQUEDA_GENERAL_IGUALA.Codigo, Variables.G_MDL_INTERNO_CODIGODESCRIPCION_TIPOBUSQUEDA_GENERAL_IGUALA.Descripcion), "X", Colores.G_COLOR_LETRA_INCORRECTO, Colores.G_COLOR_LETRA_INCORRECTO, false, Fuentes.G_FONT_SIGMAERP));

            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_TarifaPromocion_VentasCompras_Modelo.Desactivado_Texto), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_TarifaPromocion_VentasCompras_Modelo.Desactivado_Texto), "Act/Desact", G_ENUM_TIPOSDATOS.TEXT, false, 80, true, true, true, false, nameof(INTERNO_TarifaPromocion_VentasCompras_Modelo.Desactivado_Texto), lst_INTERNO_ABS_Listado_CondicionesColores_Modelo_DESACTIVADO, false));
        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }

        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_COM_SOLICITUDOFERTALINEA_TARIFASPROMOCIONES);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_COM_SOLICITUDOFERTALINEA_TARIFASPROMOCIONES;
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_TarifaPromocion_VentasCompras_Modelo.Orden);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
